int cx, cy;
float secondsRadius, minutesRadius, hoursRadius, clockDiameter;

void setup() {
  size(200, 200);
  stroke(255);
  smooth();

  int radius = min(width, height) / 2;
  secondsRadius = radius * 0.60;
  minutesRadius = radius * 0.45;
  hoursRadius = radius * 0.15;
  clockDiameter = radius * 0.10;

  cx = width / 2-6;
  cy = height / 2-6;

  PFont metaBold;
  metaBold = loadFont("Arial-Black-48.vlw"); 
  textFont(metaBold,12);
}

void draw() {
  background(126);

  // Draw the clock background
  //fill(80);
  //noStroke();
  noFill();
  ellipse(cx, cy, minutesRadius*2+15, minutesRadius*2+15);
  ellipse(cx, cy, hoursRadius*2+30, hoursRadius*2+30);
  ellipse(cx, cy, clockDiameter - 10, clockDiameter - 10);

  // Angles for sin() and cos() start at 3 o'clock;
  // subtract HALF_PI to make them start at the top
  float s = map(second(), 0, 60, 0, TWO_PI) - HALF_PI;
  float m = map(minute() + norm(second(), 0, 60), 0, 60, 0, TWO_PI) - HALF_PI; 
  float h = map(hour() + norm(minute(), 0, 60), 0, 24, 0, TWO_PI * 2) - HALF_PI;

  // Draw the hands of the clock
  stroke(255);
  text(hour(), cx + cos(h) * hoursRadius * .6,  cy + sin(h) * hoursRadius * .6);
  text(minute(),  cx + cos(m) * minutesRadius-12, cy + sin(m) * minutesRadius);
  text(second(),cx + cos(s) * secondsRadius-2,  cy + sin(s) * secondsRadius+6);

  // Draw the minute ticks
  strokeWeight(2);
   beginShape(POINTS);
  for (int a = 0; a < 360; a+=6) {
     float x = cx + cos(radians(a)) * secondsRadius;
    float y = cy + sin(radians(a)) * secondsRadius;
    vertex(x, y);
  }
  endShape();
}

