/**
 * Background Image. 
 * 
 * This example presents the fastest way to load a background image
 * into Processing. To load an image as the background, it must be
 * the same width and height as the program.
 */

// The next line is needed if running in JavaScript Mode with Processing.js
/* @pjs preload="moonwalk.jpg"; */

PImage bg, img;
int y;

void setup() {
  size(640, 360);
  // The background image must be the same size as the parameters
  // into the size() method. In this program, the size of the image
  // is 640 x 360 pixels.
  bg = loadImage("moonwalk.jpg");

  // build gradient
  img = createImage(width, 230, ARGB);
  for (int i = 0; i < img.pixels.length; i++) {
    float a = map(i, 0, img.pixels.length, 255, 0);
    img.pixels[i] = color(0, 153, 204, a);
  }
}

void draw() {
  background(bg);
  strokeWeight(5);
  stroke(226, 204, 0);
  
  line(0, y, width, y);
  y++;
  if (y > height) {
    y = 0;
  }
  image(img, 0, y);
  //image(img, mouseX-img.width/2, mouseY-img.height/2);
}

import java.util.Calendar; 
void keyPressed() {
  if (key=='s' || key=='S') {
    saveFrame(timestamp()+".png");
  }
}

String timestamp() {
  return String.format("%1$ty%1$tm%1$td_%1$tH%1$tM%1$tS", Calendar.getInstance());
}

