// draw live video


import processing.video.*;
Capture video;


// Size of each cell in the grid, ratio of window size to video size
int rectSize = 32;
// Number of columns and rows in our system
int cols, rows, videoCols, videoRows;


void setup() {
  size(640, 480, P2D);
  frameRate(30);

  // Initialize columns and rows
  cols = width/rectSize;
  rows = height/rectSize;
  videoCols=80;
  videoRows=60;
  
  video = new Capture(this,videoCols,videoRows,30);
  video.start();
  noStroke();
}


void draw() { 
  if (video.available()) {
    video.read();
  }
  // Read image from the camera
  if (video.available()) {
    video.read();
  }
  video.loadPixels();
  
  // Begin loop for columns
  for (int i = 0; i < cols; i++) {
    // Begin loop for rows
    for (int j = 0; j < rows; j++) {
      
      // Where are we, pixel-wise?
      int x = i*rectSize;
      int y = j*rectSize;
      // Looking up the appropriate color in the pixel array
      color c = video.pixels[i*videoRows/rows + j*video.width*videoCols/cols];
      fill(c);
//      stroke(0);
      rect(x,y,rectSize,rectSize);
    }
  }

}

