// based on
/**
 * Load and Display 
 * 
 * Images can be loaded and displayed to the screen at their actual size
 * or any other size. 
 */

// The next line is needed if running in JavaScript Mode with Processing.js
/* @pjs preload="moonwalk.jpg"; */

/*
 Read the pixel color using 2 ways
 1) Using the get() command you read the color of the x,y cordinates 
 http://processing.org/reference/get_.html
 2) Using the pixels[] command you read the color of each pixel in linear way
 http://processing.org/tutorials/pixels/
 
 Modified by Angelos Floros, September 2013
 */

PImage img;  // Declare variable "a" of type PImage

int cols, rows; // Number of columns and rows in our system
int rectSize=10; // rectsize
color c; // color of the rectangles

void setup() {
  size(640, 360);
  // The image file must be in the data folder of the current sketch 
  // to load successfully
  img = loadImage("moonwalk.jpg");  // Load the image into the program  
  
  cols=width/rectSize; // column number of pattern
  rows=height/rectSize; // row number of pattern
  println(img.width + "," + img.height);
}

void draw() {
  img.loadPixels(); // load the pixels

    for (int i=0; i<cols; i++) {
    for (int j=0; j<rows; j++) {
      int x=i*rectSize;
      int y=j*rectSize;

      // READ COLORS, use one or another
      // color c =img.get(x, y); // read using x,y cordinates
      color c = img.pixels[x + y*img.width]; // read the pixels in linear way

      fill(c);
      rect(x, y, rectSize, rectSize);
    }
  }
}

