//boolean variable to keep track of when there's a new frame
//boolean newFrame = false;
import processing.video.*; 

int video_width  = 320; 
int video_height = 240; 
int num_pixels = (video_width * video_height); 
int previous_frame[]; 

Capture video;

void setup()
{
  //set up size of window and video
  size(320, 240);
  frameRate(60);
  loadPixels();
  previous_frame = new int [num_pixels]; 

  video = new Capture(this, video_width, video_height, 30); 
  // Start capturing the images from the camera
  video.start(); 
  background(0);
}

void captureEvent(Capture video) {
  video.read();
}

void draw()
{ 
  background(0);

  for (int x = 0; x < video.width; x++) {
    for (int y = 0; y < video.height; y++ ) {
      //calculate the 1D location from a 2D grid
      int loc = x + y*video.width;

      int threshold = 100;
      //calculate a threshold from 0-255 based on mouseX
      // int threshold = int(((float) mouseX / width) * 255);
      
      color c;
      
      //do a threshold test based on brightness
      //the resulting pixel is only white or black
      if (brightness(video.pixels[loc]) > threshold) {
        c = color(255, 255, 255);
      } 
      else {
        c = color(0, 0, 0);
      }
      pixels[loc] = c;
    }
  }
  updatePixels();
}

