
PImage bg;

import processing.video.*;
Capture video;

int cellSize = 20;
int cols, rows;
// Saved background
PImage backgroundImage;
// How different must a pixel be to be a foreground pixel
float threshold = 80;

void setup()
{
  size(1280, 960);
  cols = width / cellSize;
  rows = height / cellSize;
  colorMode(RGB, 255, 255, 255, 100);
  rectMode(CENTER);
  video = new Capture(this, width, height, 15);
  video.start();

  // Create an empty image the same size as the video
  backgroundImage = createImage(video.width, video.height, RGB);

  frameRate(30);
}


void draw()
{

  if (video.available()) {
    video.read();
    video.loadPixels();
    background(255);

    for (int i = 0; i < cols; i++) {
      for (int j = 0; j < rows; j++) {
        int x = i * cellSize;
        int y = j * cellSize;
        int loc = (video.width - x - 1) + y*video.width;
        //  color c = video.pixels[loc];

        color fgColor = video.pixels[loc]; // Step 2, what is the foreground color
        color bgColor = backgroundImage.pixels[loc];

        // Step 4, compare the foreground and background color
        float r1 = red(fgColor);
        float g1 = green(fgColor);
        float b1 = blue(fgColor);
        float r2 = red(bgColor);
        float g2 = green(bgColor);
        float b2 = blue(bgColor);
        float diff = dist(r1, g1, b1, r2, g2, b2);

        // Step 5, Is the foreground color different from the background color
        if (diff > threshold) {
          // If so, display the foreground color
          //pixels[loc] = fgColor;
          fill(0);
          noStroke();
          rect(x + cellSize/2, y + cellSize/2, cellSize, cellSize);
        } else {
          // If not, display green
          //  pixels[loc] = color(0,255,0); // We could choose to replace the background pixels with something other than the color green!
        }


        //        float sz = (brightness(c) / 255.0) * cellSize;
        //        fill(0);
        //        noStroke();
        //        rect(x + cellSize/2, y + cellSize/2, sz, sz);
      }
    }
  }
}


void mousePressed() {
  // Copying the current frame of video into the backgroundImage object
  // Note copy takes 5 arguments:
  // The source image
  // x,y,width, and height of region to be copied from the source
  // x,y,width, and height of copy destination
  backgroundImage.copy(video,0,0,video.width,video.height,0,0,video.width,video.height);
  backgroundImage.updatePixels();
}

