// draw live video


import processing.video.*;
Capture video;


// Size of each cell in the grid, ratio of window size to video size
int videoScale = 8;
// Number of columns and rows in our system
int cols, rows;
color c;

void setup() {
  size(640, 480, P2D);
  frameRate(30);

  // Initialize columns and rows
  cols = width/videoScale;
  rows = height/videoScale;
  video = new Capture(this, cols, rows, 30);
  //  video = new Capture(this, width, height, 30);
  video.start();
  noStroke();
}


void draw() { 
  if (video.available()) {
    video.read();
  }
  // Read image from the camera
  if (video.available()) {
    video.read();
  }
  video.loadPixels();

  // Begin loop for columns
  for (int i = 0; i < cols; i++) {
    // Begin loop for rows
    for (int j = 0; j < rows; j++) {

      // Where are we, pixel-wise?
      int x = i*videoScale;
      int y = j*videoScale;
      // Looking up the appropriate color in the pixel array

      if (mouseX >= x && mouseX <= x+videoScale && mouseY >= y && mouseY <= y+videoScale) {
        c = color(255);
      } 
      else {
        c = video.pixels[i + j*video.width];
      }
      fill(c);


      //      stroke(0);
      rect(x, y, videoScale, videoScale);
    }
  }
}

