/**
 * based on 'Loop' sketch. 
 * 
 * P3D is required 
 * Distorts the shape of image or video
 * A tool for 3D Projection 
 */

import processing.video.*;

Movie myVideo1;

// video resolution
int Video1Width=160;
int Video1Height=120;

// Define the coordinates of the spape
// shape of video projection
// based on vertex representation method

// METHOD A
int tlX=10; // top left corner on X axis
int tlY=120; // top left corner on Y axis

int trX=480; // top right corner on X axis
int trY=5; // top right corner on Y axis

int brX=395; // bottom right corner on X axis
int brY=490; // bottom right corner on Y axis

int blX=40; // bottom left corner on X axis
int blY=490; // bottom left corner on Y axis

// OR

// METHOD B
// int[] cordsVid1 = {tlX, tlY, trX, trY, brX, brY, blX, blY};
int[] cordsVid1 = {10, 120, 480, 5, 495, 490, 40, 490};


void setup() {
  size(800, 600, P3D);
  background(0);
  // Load and play the video in a loop
  myVideo1 = new Movie(this, "station.mov");
  myVideo1.loop();
  frameRate(30);
  noStroke();
}

void movieEvent(Movie myVideo1) {
  myVideo1.read();
}

void draw() {
  // activate only one method
  // there are exactly the same
methodA();
//methodB();

}

void methodA() {
  beginShape();
  texture(myVideo1);
  vertex(tlX, tlY, 0, 0);
  vertex(trX, trY, Video1Width, 0);
  vertex(brX, brY, Video1Width, Video1Height);
  vertex(blX, blY, 0, Video1Height);
  endShape(); 
}

void methodB() {
  beginShape();
  texture(myVideo1);
  vertex(cordsVid1[0], cordsVid1[1], 0, 0);
  vertex(cordsVid1[2], cordsVid1[3], Video1Width, 0);
  vertex(cordsVid1[4], cordsVid1[5], Video1Width, Video1Height);
  vertex(cordsVid1[6], cordsVid1[7], 0, Video1Height);
  endShape(); 
}

